/// <amd-module name="@typedorm/common/metadata-storage" />
import { AUTO_GENERATE_ATTRIBUTE_STRATEGY, EntityTarget } from '@typedorm/common';
import { IndexOptions, Table } from './table';
export declare type PrimaryKey = SimplePrimaryKey | CompositePrimaryKey;
export declare type SimplePrimaryKey = {
    partitionKey: string;
};
export declare type CompositePrimaryKey = {
    partitionKey: string;
    sortKey: string;
};
export declare type Indexes = {
    [key: string]: IndexOptions;
};
export interface EntityRawMetadataOptions {
    name: string;
    target: EntityTarget<any>;
    primaryKey: PrimaryKey;
    indexes?: Indexes;
    table?: Table;
}
export interface AttributeRawMetadataOptions {
    name: string;
    type: any;
    unique?: boolean;
}
export interface AutoGenerateAttributeRawMetadataOptions extends AttributeRawMetadataOptions {
    strategy: AUTO_GENERATE_ATTRIBUTE_STRATEGY;
    autoUpdate?: boolean;
}
export declare class MetadataStorage {
    private _entities;
    private _attributes;
    constructor();
    getRawAttributesForEntity<Entity>(entityClass: EntityTarget<Entity>): (AutoGenerateAttributeRawMetadataOptions | AttributeRawMetadataOptions)[];
    getRawEntityByTarget<Entity>(entityClass: EntityTarget<Entity>): EntityRawMetadataOptions;
    addRawAttribute<Entity>(entityClass: EntityTarget<Entity>, attribute: AttributeRawMetadataOptions): void;
    addRawEntity(entity: EntityRawMetadataOptions): void;
    get entities(): EntityRawMetadataOptions[];
    get attributes(): (AutoGenerateAttributeRawMetadataOptions | AttributeRawMetadataOptions)[][];
}
